//     .

template <typename T>
string NumToString( T Num, const bool CheckType = true, const int digits = 2 )
{
  if (CheckType && (OrderType() == OP_SELL))
    Num = -Num;

  return(((Num > 0) ? "+" : "") + ((typename(T) == "double") ? ::DoubleToString(Num, digits) : (string)Num));
}

int PriceToPips( const double Price, const double point )
{
  return(point ? ((int)(Price / point + 0.1)) : 0);
}

int ProfitToPips( const double PriceClose, const double PriceOpen, const double point )
{
  return(PriceToPips(PriceClose, point) - PriceToPips(PriceOpen , point));
}

#define TOSTRING(A) #A + " = " + (string)(A) + " "

void OnStart()
{
  const int handle = FileOpen("SlipPages.txt", FILE_ANSI | FILE_TXT | FILE_WRITE);

  if (handle != INVALID_HANDLE)
  {
    const int Size = OrdersHistoryTotal();

    for (int i = 0; i < Size; i++)
      if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && (OrderType() <= OP_SELL) &&
          OrderTakeProfit() && (StringFind(OrderComment(), "[tp]") >= 0))
      {
        const string Symb = OrderSymbol();
        const string Str = Symb + " " + (OrderType() ? "SELL" : "BUY") + " " + DoubleToString(OrderLots(), 2) + " " +
                           NumToString(ProfitToPips(OrderClosePrice(), OrderTakeProfit(), SymbolInfoDouble(Symb, SYMBOL_POINT))) + "\n";

        FileWriteString(handle, Str);
      }

    FileClose(handle);
  }
}